
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>编写与.net属性窗口交互的RAD组件(五) / iVAN</title>

    <meta name="description" content="编写与.net属性窗口交互的RAD组件(五) 交互 八. 提供可交互的属性视图当你在Visual C# .NET中创建一个项目的时候,你可能会注意到属性窗口的工具栏上有一个像闪电的按钮,按下这个按钮属性窗口就会切换到事件视图,这样就可以来编辑事件处理了. 属性窗口的视图来自&quot;属性页(Property Tabs)&quot;,因此视图使用的最主要的类是PropertyTab,命名空间是System.Windows.Forms.Design.一个属性页可以和一个特别的组件.设计文档关联起来,或者是可以使用的静态关联.和组件或文档关联起 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">编写与.net属性窗口交互的RAD组件(五)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>交互</p>
<p>八、           提供可交互的属性视图<br />当你在Visual C# .NET中创建一个项目的时候，你可能会注意到属性窗口的工具栏上有一个像闪电的按钮，按下这个按钮属性窗口就会切换到事件视图，这样就可以来编辑事件处理了。</p>
<p>属性窗口的视图来自“属性页（Property Tabs）”，因此视图使用的最主要的类是PropertyTab，命名空间是System.Windows.Forms.Design。一个属性页可以和一个特别的组件、设计文档关联起来，或者是可以使用的静态关联。和组件或文档关联起来的属性页在类上用PropertyTabAttribute特性来指定。这个特性指定要创建的Tab的类型，它在属性窗口上是否显示由PropertyTabAttribute的PropertyTabScope参数来指定。指定为Component范围的属性页的可见性由有PropertyTabAttribute特性的组件的可见性来决定。Document范围的属性页则可以在当前项目的设计中都可见。他的默认值是PropertyTabScope.Component。</p>
<p>举一个例子来说，看看“FunkyButton”项目。FunkyButton是一个扩展了PropertyTab的UserControl，而且可以让我们把控件定为不规则的多边形。</p>
<p>图6. FunkyButton</p>
<p>当前选择的属性页就是属性窗口从被选择的控件的属性中得到的。属性页因此就允许来操纵显示属性的不同集合。Events页就是像属性一样以某种方式来处理事件。在这个例子中，属性页就创建了表示控件顶点的属性。</p>
<p>.NET framework中的属性用PropertyDescriptor类来封装。PropertyDescriptor本身是一个抽象类，framework中由他派生的类提供了访问组件的开放属性的方法。不过，属性窗口是直接作用在PropertyDescriptor上，而不是直接作用在属性上。因此，我们就可以写自己的PropertyDescriptor来做一些特殊的工作。在这个例子里，我们就有一个属性表示控件的顶点数，另一个就表示每一个顶点。再次注意一下，我们在属性窗口上增加页并不相应的作用在其他对象上。</p>
<p>当属性窗口向PropertyTab询问Properties的时候，它就调用GetProperties方法。对于我们的示例程序，这个方法就像下面的一样：</p>
<p>public override PropertyDescriptorCollection</p>
<p>GetProperties(ITypeDescriptorContext context, object component,</p>
<p>Attribute[] attrs)</p>
<p>{</p>
<p>// our list of props.</p>
<p>//</p>
<p>ArrayList propList = new ArrayList();</p>
<p>// add the property for our count of vertices</p>
<p>//</p>
<p>propList.Add(new NumPointsPropertyDescriptor(this));</p>
<p>// add a property descriptor for each vertex</p>
<p>//</p>
<p>for (inti = 0; i &lt; ((FunkyButton)component).Points.Count; i++)</p>
<p>{</p>
<p>propList.Add(new VertexPropertyDescriptor(this,i));</p>
<p>}</p>
<p>// return the collection of PropertyDescriptors.</p>
<p>PropertyDescriptor[] props =</p>
<p>(PropertyDescriptor[])propList.ToArray(typeof(PropertyDescriptor));</p>
<p>return new PropertyDescriptorCollection(props);</p>
<p>}</p>
<p>GetProperties仅仅是返回一些属性描述的集合。PropertyDescriptors是相当的简单，仔细查看这些代码以了解他们是怎么工作的。</p>
<p>FunkyButton同时示例了下拉列表编辑器的实现。对于每一个点，我们不是简单的输入坐标的X和Y值，我们会图示FunkyButton的形状，而且可以用图形化的方法改变点的位置。这样设置的编辑样式更加地友好。</p>
<p>图7. 图形化的点向量</p>
<p>由于订制的PropertyTab提供了属性，重载这个属性的编辑器也是很容易的。只要简单地重载PropertyDescriptor的GetEditor方法，然后返回订制组件的实例就可以了。</p>
<p>public override object GetEditor(Type editorBaseType)</p>
<p>{</p>
<p>// make sure we're looking for a UITypeEditor.</p>
<p>//</p>
<p>if (editorBaseType == typeof(System.Drawing.Design.UITypeEditor))</p>
<p>{</p>
<p>// create and return one of our editors.</p>
<p>//</p>
<p>if (editor == null)</p>
<p>{</p>
<p>editor = new PointUIEditor(owner.target);</p>
<p>}</p>
<p>return editor;</p>
<p>}</p>
<p>return base.GetEditor(editorBaseType);</p>
<p>}</p>
<p>设计编辑器同样简单。编辑器就是一个简单的UserControl，所以我们就可以像设计其他的windowsForms对象一样来做。</p>
<p>图8. Designing the editor</p>
<p>最后，当用户在属性窗口中点击下拉箭头时，我们的编辑器就可以将刚才创建UI编辑器弹出来了。PointUIEditor中的UITypeEditor.EditValue重载后就可以实现了。</p>
<p>public override object EditValue(</p>
<p>ITypeDescriptorContext context,</p>
<p>IServiceProvider sp, object value)</p>
<p>{</p>
<p>// get the editor service.</p>
<p>IWindowsFormsEditorService edSvc =</p>
<p>(IWindowsFormsEditorService)sp.GetService(typeof(IWindowsFormsEditorService));</p>
<p>// create our UI</p>
<p>if (ui == null)</p>
<p>{</p>
<p>ui = new PointEditorControl();</p>
<p>}</p>
<p>// initialize the ui with the settings for this vertex</p>
<p>ui.SelectedPoint = (Point)value;</p>
<p>ui.EditorService = edSvc;</p>
<p>ui.Target = (FunkyButton)context.Instance;</p>
<p>// instruct the editor service to display the control as a</p>
<p>// dropdown.</p>
<p>edSvc.DropDownControl(ui);</p>
<p>// return the updated value;</p>
<p>return ui.SelectedPoint;</p>
<p>}</p>
<p>九、           我们同样可以使用它<br />在你自己的应用中可以拥有和IDE属性窗一样的特性。把System.Windows.Forms.PropertyGrid的控件，添加到IDE中的ToolBox中，通过获取在ToolBox的Component标签里的PropertyGrid。</p>
<p>PropertyGrid和其他的控件工作是一样的。你可以anchor或者是Dock他，改变它的色彩等。下面的列表列出了PropertyGrid的一些有趣的属性。</p>
<p>•SelectedObject<br /> PropertyGrid要显示的对象</p>
<p>•ToolbarVisible<br /> 显示或者隐藏PropertyGrid顶端的Toolbar</p>
<p>•HelpVisible<br /> 显示或者隐藏PropertyGrid底端的帮助文本</p>
<p>•PropertySort<br /> 设置PropertyGrid的排序类型 (categorized, alphabetical, etc.).</p>
<p>这些属性都可以在设计时设置。在运行时，可以操作PropertyGrid让他显示的你的对象。下面是显示一个button的例子。在这个例子中，PorpertyGrid的帮助和toolbox都被隐藏了。就像上面提到的，你可以设置他自己的属性。</p>
<p>图9. 隐藏了toolbar和帮助信息的PropertyGrid</p>
<p>十、           结论<br />NET framework和Visual Studio .NET给属性窗口增加了相当多的功能。由于属性窗口是RAD的核心，这些特性可以在保持易用性的同时有很多的扩展，也因此在Visual Basic中用的很普遍。就像可以在我们的程序中使用PropertyGrid，我们可以把更多的时间放在如何写好程序上，从而简化我们的UI工作。</p>
<p>-----------------------------------------------------------------------------------------</p>
<p>&lt;&lt;&lt;&lt;&lt;&lt;&lt;&lt;&lt;&lt;&lt;&lt;&lt;&lt;&lt;&lt;&lt;&lt;&lt;待续&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-20 10:29:59</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%b1%9e%e6%80%a7/" title="属性">属性</a>, <a href="https://www.iamivan.net/tag/%e7%bc%96%e8%be%91%e5%99%a8/" title="编辑器">编辑器</a>, <a href="https://www.iamivan.net/tag/%e7%aa%97%e5%8f%a3/" title="窗口">窗口</a>, <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e6%8e%a7%e4%bb%b6/" title="控件">控件</a>, <a href="https://www.iamivan.net/tag/propertygrid/" title="propertygrid">propertygrid</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>编写与.net属性窗口交互的RAD组件(五)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/7M018Dp.html" rel="bookmark">编写与&period;NET属性窗口交互的RAD组件（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				交互 一. 摘要:这篇文章将告诉你如何开发与.NET属性窗口交互的RAD组件 二. 内容:简介 属性窗口可以做什么 基础知识:使用Attribute来订制属性窗口的显示 扩展属性和字符串转换:TypeConverter和属性窗口 编写和显示订制的类型 提供可交互的属性视图 我们同样可以使用它 结论 三. 简介在Visual Basic中,属性窗口是真正实现快速应用开发的一个关键工具(RAD:Rapid Application Development).在Visual Studio .NET中,属			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/7b2XW3p.html" rel="bookmark">编写与&period;NET属性窗口交互的RAD组件（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				交互 五. 基础知识:使用Attribute来订制属性窗口的显示控制显示的机制和用IDL定义的组件是一样的,不过是增加了元数据特性.控制显示使用最普遍的特性是BrowsableAttribute.默认状态下,属性窗口显示对象中定义的所有的公开的.可读的(即public.有get或者set方法的)属性,并且把他们放在&quot;杂项(Misc)&quot;类别中.下面是一个简单的组件例子: public class SimpleComponent : System.ComponentModel.Compon			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/gpkomjp.html" rel="bookmark">编写与&period;NET属性窗口交互的RAD组件（三）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				交互 六. 扩展属性和字符串转换:TypeConverter和属性窗口.NET属性窗口最重要的一个特性就是可以显示嵌套的属性,这样就提供了比属性类别更加细化和更有逻辑的分类.嵌套属性对于类目显示和排序显示都是适用的.这样可以让属性列表更加紧凑.比如我们用带有子属性X和Y的一个Location属性来代替Top和Left两个属性就更加合理. 图2.嵌套属性 不过,如何来决定一个属性可以展开呢?这些不是由属性窗口来决定,而是取决于属性自己的类型.在.NET framework中,每一种类型都是和一个T			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/4MYWkez.html" rel="bookmark">编写与&period;NET属性窗口交互的RAD组件（四）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				交互 七. 编写和显示订制的类型属性窗口中的编辑有如下三种工作方式:一,有些场合可以作为字符串来编辑,然后由TypeConverter来实现类型的转换.二,可以显示一个下拉列表来选择值.三,一个省略按钮提供其他的UI界面来编辑值,比如FileDialog和FontPicker.我们已经讲过了字符串形式,接着我们就来看下拉列表. .NET framework已经包含了好几种下拉列表的例子,如Color,AccessibleRole,Dock等属性.我们从下图可以看到下拉列表的具体实现. 图4. 下			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/2pLxYAp.html" rel="bookmark">编写与&period;net属性窗口交互的RAD组件&lpar;六&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				交互 又到周末了,有了那么点属于自己的时间,因此就把上次没有发完的部分全部补上了,正文部分发到第五篇的时候,实际上已经发完了,现在要发的就是兑现我在自序中说过的话,将自己用TypeConverter实现的类型转换器的源码也一并发出来,在自序中没有把原因说得很明白,如果你看了前面几章又动手实验过的话,就会知道这个原因,我照着文中所说的方法构造了自己的数据类型转换器,IDE的属性窗口的确也能正确展开并解析子属性,但当我修改子属性的时候,发现有两个问题,一是子属性无法修改(这个问题产生的具体原因我忘了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/1MvLw5z.html" rel="bookmark">JavaScript实际应用：子窗口和父窗口交互</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				javascript|父窗口|交互|子窗口 最近项目开发中需要子窗口和父窗口交互的内容,基本上无非就是把子窗口的信息传递给父窗口,并且关闭自己等等,或者是父窗口把自己的信息传递给子窗口等等. 1.父窗口传递信息给子窗口 看代码实例:&lt;script language=javascript&gt; function outPut(){ //获取父窗口的文本信息赋值给text var text = document.abc.text.value; //打开子窗口,并且把操作句柄赋值给win变量,以下所有操			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baddQNz.html" rel="bookmark">Win10如何打开系统属性窗口有哪些方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  此前系统之家介绍Win10常用快捷键时,讲过按Win+Pause&amp;Break键可以快速打开系统属性.现在小编再给大家介绍两个打开Win10系统属性的方法,供大家参考学习. 方法一 右键点击桌面这台电脑图标,选择属性. 方法二 打开这台电脑文件夹,在计算机标签中,点击属性. 系统属性窗口介绍了部分电脑的配置信息,但并不全面,通过DirectX诊断工具能查看更详细的配置信息.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDYq9Ob.html" rel="bookmark">U盘属性窗口中没有安全选项解决办法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  现在,很多人在办公和生活中都需要使用到U盘,并且用U盘装系统的情况并不少.通常,里面很可能装有比较重要的资料和文件,所以不少朋友都会将自己的U盘设置密码,设置访问权限等等,而这个时候,咱们就需要在U盘属性窗口中的安全选项卡中完成操作,但是最近有朋友发现,自己的U盘属性窗口中,没有发现安全选项,这个时候要怎么办呢? U盘属性窗口中没有安全选项解决办法 原因分析:一般来说,U盘属性窗口中的安全选项卡消失是因为U盘的格式被修改成了FAT32造成的,如果想要重新找回安全选项,咱们只需要将U盘格式重新			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MywJAvz.html" rel="bookmark">U盘的属性窗口中没有安全选项怎么办？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  咱们日常办公操作中需要使用U盘装系统的情况并不少,当然U盘也是咱们比较私密的东西,里面很可能装有比较重要的资料和文件,所以不少朋友都会将自己的U盘设置密码,设置访问权限等等,而这个时候,咱们就需要在U盘属性窗口中的安全选项卡中完成操作,但是最近有朋友发现,自己的U盘属性窗口中,没有发现安全选项,这个时候要怎么办呢? 原因分析:一般来说,U盘属性窗口中的安全选项卡消失是因为U盘的格式被修改成了FAT32造成的,如果想要重新找回安全选项,咱们只需要将U盘格式重新格式化为NTFS格式即可. 1.首			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zen1Ab.html" rel="bookmark" class="title">在excel怎么运用计算公式进行运算？</a>
					<div>
						  在excel建立财务等报表后,通常都需要进行相关数据计算,这也是我们使用excel程序的目的语便利所在.在进行数据计算时,需要建立公式来实现,而在使用公式时,需要引用单元格的值进行计算,那么在ex ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apXd45p.html" rel="bookmark" class="title">nginx 部署&colon;在cygwin下部署PHP环境&comma;mssql&plus;PHP &plus;nginx&plus;freetds</a>
					<div>
						因为公司的环境是在linux下,所以想在自己的机器上搭建个模仿linux的环境 环境为linux +mssql+PHP +nginx+freetds 于是就想到了cygwin 去http://www. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKj15z.html" rel="bookmark" class="title">Fireworks 制作扇子展开动画</a>
					<div>
						这个例子是针对补间实例,复制帧的应用,也没什么诀窍:主要要有耐心 1.新建一画布,画一上宽下窄矩形并转成图形元件,克隆一次,将克隆出的图摆放如图示: 2.做补间实例设置数为22,也就是说现在有了总共2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bog7Db.html" rel="bookmark" class="title">SQL SERVER 与ACCESS、EXCEL的数据转换</a>
					<div>
						access|excel|server|数据|转换 SQL SERVER 与ACCESS.EXCEL的数据转换   熟悉SQL SERVER 2000的数据库管理员都知道,其DTS可以进行数据的导入导 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6K5Lp.html" rel="bookmark" class="title">ASP程序性能测试报告&lpar;六&rpar;</a>
					<div>
						程序|性能 七.最好用哪种方法提取记录集? 到目前为止我们一直通过创建Recordset对象提取记录集,但是ADO也提供了间接的记录集提取方法.下面的测试比较ADO__03.asp和直接从Connec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AVWRp.html" rel="bookmark" class="title">用ADO管理SQL Server数据库及其设备</a>
					<div>
						    微软公司的SQL Server是目前小型网络中常用的数据库管理系统之一.面向这种网络数据库的应用程序也在日益增多,这种网络数据库应用系统的正常运行,一般都依赖于已经存在的用户数据库.创建数据库 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7nOab.html" rel="bookmark" class="title">JAVA提高教程&lpar;11&rpar;-认识Map</a>
					<div>
						Map可以为某些数据提供快速查找功能,通过关键字(key)可以快速的得到对应的 Value,而不用像List那样需要大范围的遍历或特别的算法. 1. 源代码 1.import java.util.Ar ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z722dXp.html" rel="bookmark" class="title">谷歌浏览器记住的账号和密码如何批量删除</a>
					<div>
						  如果我们是使用电脑的时候,在浏览器中选择保存密码,这样以来电脑中的浏览器就会记住帐户密码并保存到记录中.不过用户害怕其他人从浏览器中查看到自己的帐户和密码,所以想将将记录中保存的密码删除,可是又不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8BGlp.html" rel="bookmark" class="title">SKETCH用户如何看待这次PS CC 2015的新功能？</a>
					<div>
						  这篇文章以一个比较激进的角度看待此次 Photoshop 升级,更多是站在了 Sketch 的一边,译者@窒息红Leon 认为这并不够客观,仅提供国外设计同行的一些想法.另外,Medium 上也有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EJX4M.html" rel="bookmark" class="title">win7升级win8系统后鼠标出现间歇性失灵的两种解决方法</a>
					<div>
						  方法一: 1.首选需要返回到win8系统的传统桌面位置,然后调出win8电脑的右键菜单, 2.在打开的菜单中,依次点击选择更改电脑设置-电脑和设备-鼠标和触摸板选项里的触摸板是否设置的无延迟,如果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z421o9M.html" rel="bookmark" class="title">如何在Windows8中修改当前所在地理位置</a>
					<div>
						  步骤1:打开&quot;控制面板&quot;; 步骤2:在&quot;时钟.语言和区域&quot;上左键单击; 步骤3:在&quot;更改位置&quot;上左键单击; 步骤4:选择位置标签,在&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72E1Xp.html" rel="bookmark" class="title">Windows计算机中丢失SETUPAPI&period;dll</a>
					<div>
						  Windows计算机中丢失SETUPAPI.dll的解决方法 Windows 2012 最近出现 计算机中丢失SETUPAPI.dll 的问题 查看日志未果,查看系统更新,好几个失败,没理! 是由 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLoNnb.html" rel="bookmark" class="title">RVDS 3&period;1 下载地址及破解方法</a>
					<div>
						RealView Development Suite 3.1  RVDS 3.1下载地址:https://silver.arm.com/download/Development_Tools/RVDS/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBJg8z.html" rel="bookmark" class="title">afnetworki-ios  AFNetworking网络请求出现415错误</a>
					<div>
						问题描述 ios AFNetworking网络请求出现415错误 POST请求,参数上传是json.没有参数的情况下,后台能接受到请求,加上参数之后就出现415错误,很纠结,我传给后台的也是json数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6JQqM.html" rel="bookmark" class="title">java解决hash算法冲突</a>
					<div>
						看了ConcurrentHashMap的实现, 使用的是拉链法. 虽然我们不希望发生冲突,但实际上发生冲突的可能性仍是存在的.当关键字值域远大于哈希表的长度,而且事先并不知道关键字的具体取值时.冲突就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJk2lJb.html" rel="bookmark" class="title">首个全民国家安全教育日 安防知识你知多少？</a>
					<div>
						 今年4月15日,是&lt;中华人民共和国国家安全法&gt;颁布后首个全民国家安全教育日.借此契机,为大家分享一些安防基础知识. 2014年4月15日,中央国家安全委员会第一次全体会议召开,在这次会议 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrqJWM.html" rel="bookmark" class="title">关于水晶报表的问题和PrintDocument控件</a>
					<div>
						问题描述 我想在水晶报表的基础上禁用GrystalReportViewer它本身自带的打印功能,然后在原来它的那个打印位置点击会弹出我自己定义的窗体,Form1,然后我自己设计Form1把PageSe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Y3d4M.html" rel="bookmark" class="title">自定义log日志输出到文件中保存</a>
					<div>
						程序调试日志,可以 通过printf直接输出到屏幕上面进行调试.在默写特定的情况下面,可以将日志保存到文件中,后期进行查阅调试. log.h //log.h #ifndef _ITCAST_LOG_H ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYj1arp.html" rel="bookmark" class="title">opencv-open cv调试时总是说错误</a>
					<div>
						问题描述 open cv调试时总是说错误 #include &quot;opencv2/highgui/highgui.hpp&quot; #include &quot;opencv2/imgproc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkeJD7b.html" rel="bookmark" class="title">内外网数据库数据同步问题</a>
					<div>
						问题描述 公司有一个项目,需要实现内外网数据库的数据同步.向大神请教方案.项目场景如下,有三台服务器:1.阿里云:有服务端程序和数据库(主服务器)2.A公司:有服务端程序和数据库3.B公司:有服务端程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RlDkb.html" rel="bookmark" class="title">LIGO 用 Python 分析引力波数据</a>
					<div>
						LIGO 用 Python 分析引力波数据 美国科学家11日宣布,他们去年9月首次探测到引力波.这一发现印证了物理学大师爱因斯坦100年前的预言.宣布这一发现的,是激光干涉引力波天文台(LIGO)的负 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqR9oYp.html" rel="bookmark" class="title">用DNA存储数据</a>
					<div>
						用DNA存储数据,这已经不是不可能实现的任务.我们之前为大家介绍过哈佛大学在DNA存储方面的工作,他们将700TB的数据存进了仅仅1克DNA之中.关于DNA存储的研究也不断地有着新进展,不久前,欧洲分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjL0Emp.html" rel="bookmark" class="title">华为称拿下欧洲电信设备市场10&percnt;份额</a>
					<div>
						北京时间8月24日下午消息,据国外媒体今日报道,华为西欧业务部门副总裁蒂姆·沃特金斯(Tim Watkins)表示,该公司在欧洲电信设备市场份额已达10%,预计今年会进一步提高,并已在美国市场取得重大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94yqVb.html" rel="bookmark" class="title">同胞不同命：微信的尴尬与手Q的孤独</a>
					<div>
						微信5.0和QQ 4.2.1同时发布,这对同胞兄弟终于第一次出现在了同一条起跑线上,接下来就是铺天盖地的刷屏,会玩不会玩的玩家都忙着打飞机,冲排行,秀成绩,靠谱不靠谱的专家都忙着解读.分析.猜结局,好 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60YxNz.html" rel="bookmark" class="title">搜狗SR值对网站关键词排名的影响</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 凭借&quot;输入法-浏览器-搜 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvn5YAM.html" rel="bookmark" class="title">java jaxb-JAXB如何映射对象的某个属性为XML标签的值：</a>
					<div>
						问题描述 JAXB如何映射对象的某个属性为XML标签的值: 有对象class A{ String p1=&quot;xxx&quot;; String p2=&quot;yyy&quot;} 期望映射 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK51vLp.html" rel="bookmark" class="title">《应用时间序列分析：R软件陪同》&mdash;&mdash;导读</a>
					<div>
						前言 首先,一些教材偏重于数学理论和推导.作者多为数学出身,他们习惯于数学的严格性和导出精确而又漂亮的数学结论.这些书适用于那些愿意为时间序列的数学理论研究做出贡献的读者. 其次,国内教材中一元时间序 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgDRAM.html" rel="bookmark" class="title">&lbrack;分享&rsqb;基于networkComms c&num;通信框架的文件上传程序（包含全部源码）</a>
					<div>
						问题描述 本来想要研究下基于networkcomms的xamarin上的安卓开发,可是装了vs2015电脑太卡,暂时先放一下.把以前的程序翻出来改一下,分享给大家.networkcommsv3与v2用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRJxZp.html" rel="bookmark" class="title">阿里宣布Atlas开源，提升大规模团队移动开发效率</a>
					<div>
						继 Weex 之后,阿里在移动技术领域又有开源大动作. 3月13日,手机淘宝安卓客户端容器化框架 Atlas 正式宣布开源.Atlas 由阿里巴巴移动团队自研,以容器化思路解决大规模团队协作问题,实现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M608xJz.html" rel="bookmark" class="title">工业生产领域机器视觉技术嵌入式应用趋势</a>
					<div>
						随着柔性制造系统的推广和传感.模式识别等技术的发展,造业自动化需求凸显,推动机器视觉技术在工业生产领域的应用,自动化系统解决方案不断得到优化.随着图像处理能力和速度的增强.光器件性能的提高以及成本相对 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
